{{- define "gmagpie.apiserver.labels" -}}
{{- if .Values.apiserver.labels }}
{{- range $key, $value := .Values.apiserver.labels }}
{{ $key }}: {{ $value | quote }}
{{- end }}
{{- else }}
app: {{- .Release.Name }}-apiserver
{{- end }}
{{- end -}}

{{- define "gmagpie.apiserver.podLabels" -}}
{{- if .Values.apiserver.podLabels }}
{{- range $key, $value := .Values.apiserver.podLabels}}
{{ $key }}: {{ $value | quote }}
{{- end}}
{{- end }}
{{ include "common.sidecar.istio" (dict "podLabels" .Values.apiserver.podLabels "global" .Values.global) }}
{{- end -}}

{{- define "gmagpie.controllermanager.labels" -}}
{{- if .Values.controllermanager.labels }}
{{- range $key, $value := .Values.controllermanager.labels}}
{{ $key }}: {{ $value | quote }}
{{- end}}
{{- else}}
app: {{- .Release.Name }}-controllermanager
{{- end }}
{{- end -}}

{{- define "gmagpie.controllermanager.podLabels" -}}
{{- if .Values.controllermanager.podLabels }}
{{- range $key, $value := .Values.controllermanager.podLabels }}
{{ $key }}: {{ $value | quote }}
{{- end }}
{{- end }}
{{ include "common.sidecar.istio" (dict "podLabels" .Values.controllermanager.podLabels "global" .Values.global) }}
{{- end -}}

{{- define "gmagpie.ui.labels" -}}
{{- if .Values.ui.labels }}
{{- range $key, $value := .Values.ui.labels }}
{{ $key }}: {{ $value | quote }}
{{- end}}
{{- else}}
app: {{- .Release.Name }}-ui
{{- end }}
{{- end -}}

{{- define "gmagpie.ui.podLabels" -}}
{{- if .Values.ui.podLabels }}
{{- range $key, $value := .Values.ui.podLabels }}
{{ $key }}: {{ $value | quote }}
{{- end }}
{{- end }}
{{ include "common.sidecar.istio" (dict "podLabels" .Values.ui.podLabels "global" .Values.global) }}
{{- end -}}


{{- define "dsnHostAndPort" -}}
{{- $db := index . -}}
{{- if eq $db.driver "mysql" -}}
{{ regexReplaceAll ".*@\\w+\\((.*?):(\\d+)\\).*" $db.dsn "${1} ${2}" }}
{{- end -}}
{{- if or (eq $db.driver "postgres") (eq $db.driver "kingbase") -}}
{{- $host := regexReplaceAll ".*host=([^ ]+).*" $db.dsn "${1}" -}}
{{- $port := regexReplaceAll ".*port=([^ ]+).*" $db.dsn "${1}" -}}
{{- printf "%s %s" $host $port -}}
{{- end -}}
{{- end -}}

{{- define "dsn" -}}
{{- $db := index . -}}
{{- if and (eq $db.driver "mysql") (not (contains "?" $db.dsn)) -}}
{{ print $db.dsn "?charset=utf8mb4&multiStatements=true&parseTime=true" }}
{{- else -}}
{{ $db.dsn }}
{{- end -}}
{{- end -}}
